From diaframe Require Import proofmode_base.
From iris.bi Require Import bi.
From iris.proofmode Require Import proofmode.

Section test.
  Context {PROP : bi}.
  Context (A : Type) (f : A → boolO).

  Lemma test_bool_ineq (a : A) : ⌜f a = true⌝ ⊢@{PROP} ⌜f a ≠ false⌝.
  Proof. iSteps. Qed.

  Lemma test_bool_negb_eq (a : A) : ⌜f a = true⌝ ⊢@{PROP} ⌜negb $ f a = false⌝.
  Proof. iSteps. Qed.

  Lemma test_bool_negb_eq2 (a : A) : ⌜negb (f a) = true⌝ ⊢@{PROP} ⌜f a ≠ true⌝.
  Proof. iSteps. Qed.

  Lemma test_bool_negb_eq3 (a : A) : ⌜negb (f a) && true = true⌝ ⊢@{PROP} ⌜f a || false ≠ true⌝.
  Proof. iSteps. Qed.

  Lemma test_bool_negb_eq4 (a : A) : ⌜negb (f a) = true⌝ ⊢@{PROP} ⌜f a ≠ true⌝.
  Proof. iSteps. Qed.

  Lemma test_bool_negb_eq5 (a : A) : ⌜f a = true⌝ ⊢@{PROP} ⌜@eq (ofe_car boolO) (negb $ f a) false⌝.
  Proof. iSteps. Qed.

  Context (g : A → Type → boolO). 
  (* if boolO is not changed into bool everywhere, bool_solver might choke on destructing syntactically-inequal, yet convertible terms *)
  Lemma test_bool_negb_eq6 (a : A) : ⌜@eq (ofe_car boolO) (g a boolO) true⌝ ⊢@{PROP} ⌜@eq (ofe_car boolO) (negb $ g a boolO) false⌝.
  Proof. iSteps. Qed.

  (* equalities on pairs *)
  Lemma test_pair_eq1 : ⊢@{PROP} ∃ (pn : nat * nat), ⌜pn.1 = 0⌝ ∗ ⌜pn.2 = 1⌝.
  Proof. iSteps. Qed.
  (* TODO: this should also work!
  Lemma test_pair_eq2 : ⊢@{PROP} ∃ (pn : nat * nat), ⌜0 = pn.1⌝ ∗ ⌜1 = pn.2⌝.
  Proof. iSteps. Admitted. *)
End test.

(* TODO: Where to add these tests?
From diaframe.heap_lang Require Import proof_automation.

Section test.
  Context {PROP : bi}.

  Lemma test_pairV_eq1 : ⊢@{PROP} ∃ (pn : Z * Z), ⌜(#pn.1, #pn.2)%V = (#3, #4)%V⌝ ∗ (emp -∗ emp).
  Proof. iSteps. Qed.

  Lemma test_pairV_eq2 : ⊢@{PROP} ∃ (pn : Z * Z), ⌜(#3, #4)%V = (#pn.1, #pn.2)%V⌝ ∗ (emp -∗ emp).
  Proof. iSteps. Qed.
End test. *)