#!/bin/bash
set -euo pipefail
IFS=$'\n\t'

export OPAMYES=true

# Test for deps
if [ ! -d "./deps/iris" ]
then
    echo "./deps does not seems populated. Running deps/dldeps.sh"
    cd deps
    ./dldeps.sh
    cd ..
fi

# Update the package list.
echo "Updating the list of available packages..."
opam update

# Create a local switch. (We assume opam 2 is installed.)
echo "Creating a local switch..."

opam switch --switch . import packages.switch
eval "$(opam env --set-switch)"

echo "Installing custom iris packages."
opam install deps/stdpp/coq-stdpp.opam
opam install deps/iris/coq-iris.opam
opam install deps/diaframe/coq-diaframe.opam

eval $(opam env)

echo "Compiling..."
make
